import { defineStore } from 'pinia';
import { store } from '/@/store';
import { RoleEnum } from '/@/enums/roleEnum';
import { PageEnum } from '/@/enums/pageEnum';
import { Authority } from '/@/api/model/authority';
import { ROLES_KEY, TOKEN_KEY, USER_INFO_KEY } from '/@/enums/cacheEnum';
import { getAuthCache, setAuthCache } from '/@/utils/auth';
import { User } from '/@/api/model/user';
import * as UserApi from '/@/api/system/userApi';
import { useI18n } from '/@/hooks/web/useI18n';
import { useMessage } from '/@/hooks/web/useMessage';
import { router } from '/@/router';
import { usePermissionStore } from '/@/store/modules/permission';
import { RouteRecordRaw } from 'vue-router';
import { PAGE_NOT_FOUND_ROUTE } from '/@/router/routes/basic';
import { isArray } from '/@/utils/is';
import { h } from 'vue';
import { DataItem } from '/@/views/product/goods-category/type';

// import { useSocketStore } from './socket';
// import { useThingsBoard } from './thingsboard';

interface UserState {
  userInfo: Nullable<User>;
  token?: string;
  roleList: RoleEnum[];
  sessionTimeout?: boolean;
  lastUpdateTime: number;
  authorityList: Authority[];
  navList: DataItem[];
}

export const useUserStore = defineStore({
  id: 'app-user',
  state: (): UserState => ({
    // user info
    userInfo: null,
    // token
    token: undefined,
    // roleList
    roleList: [],
    // Whether the login expired
    sessionTimeout: false,
    // Last fetch time
    lastUpdateTime: 0,
    authorityList: [],
    navList: [],
  }),
  getters: {
    getUserInfo(): User {
      return this.userInfo || getAuthCache<User>(USER_INFO_KEY) || {};
    },
    getToken(): string {
      return this.token || getAuthCache<string>(TOKEN_KEY);
    },
    getRoleList(): RoleEnum[] {
      return this.roleList.length > 0 ? this.roleList : getAuthCache<RoleEnum[]>(ROLES_KEY);
    },
    getAuthorityList(): Authority[] {
      return this.authorityList;
    },
    getSessionTimeout(): boolean {
      return !!this.sessionTimeout;
    },
    getLastUpdateTime(): number {
      return this.lastUpdateTime;
    },
    /**
     * @description 经销商id 华润是0 其他不是
     */
    getDistributorId(): number {
      return this.userInfo?.distributorId as number;
    },
    /**
     * @description 是否是经销商 true 是 false
     */
    getIsDistributor(): boolean {
      return this.getDistributorId !== 0;
    },

    getNavList(): DataItem[] {
      return this.navList;
    },
  },
  actions: {
    setToken(info: string | undefined) {
      this.token = info ? info : ''; // for null or undefined value
      setAuthCache(TOKEN_KEY, info);
    },
    setRoleList(roleList: RoleEnum[]) {
      this.roleList = roleList;
      setAuthCache(ROLES_KEY, roleList);
    },
    setRoleAuthority(authorityList: Authority[]) {
      this.authorityList = authorityList;
    },
    setUserInfo(info: User | null) {
      this.userInfo = info;
      this.lastUpdateTime = new Date().getTime();
      setAuthCache(USER_INFO_KEY, info);
    },
    setSessionTimeout(flag: boolean) {
      this.sessionTimeout = flag;
    },
    resetState() {
      this.userInfo = null;
      this.token = '';
      this.roleList = [];
      this.sessionTimeout = false;
    },
    /**
     * @description: login
     */
    async login(params: any): Promise<User | null> {
      try {
        const { goHome = true, mode, ...loginParams } = params;
        const data = await UserApi.login(loginParams);
        const { token } = data as any;

        // save token
        this.setToken(token);
        return this.afterLoginAction(goHome);
      } catch (error) {
        return Promise.reject(error);
      }
    },
    async afterLoginAction(goHome?: boolean): Promise<User | null> {
      if (!this.getToken) return null;
      // get user info
      const userInfo = await this.getUserInfoAction();

      const sessionTimeout = this.sessionTimeout;
      if (sessionTimeout) {
        this.setSessionTimeout(false);
      } else {
        const permissionStore = usePermissionStore();
        if (!permissionStore.isDynamicAddedRoute) {
          const routes = await permissionStore.buildRoutesAction();
          routes.forEach((route) => {
            router.addRoute(route as unknown as RouteRecordRaw);
          });
          router.addRoute(PAGE_NOT_FOUND_ROUTE as unknown as RouteRecordRaw);
          permissionStore.setDynamicAddedRoute(true);
        }
        goHome && (await router.replace(PageEnum.BASE_HOME));
      }
      return userInfo;
    },
    async getUserInfoAction(): Promise<User | null> {
      if (!this.getToken) return null;
      const userInfo = await UserApi.info();
      const { roleList = [] } = userInfo;
      if (isArray(roleList)) {
        const roles = roleList.map((item) => item.name) as RoleEnum[];
        this.setRoleList(roles);
        const authorityList = roleList[0].authorityList as Authority[];
        if (roleList.length) this.setRoleAuthority(authorityList);
        else this.setRoleAuthority([]);
      } else {
        userInfo.roleList = [];
        this.setRoleList([]);
        this.setRoleAuthority([]);
      }
      this.setUserInfo(userInfo);
      // const socketStore = useSocketStore();
      // socketStore.startSocket();
      // const thingsboardStore = useThingsBoard();
      // thingsboardStore.startThingsBoardSocket();
      return userInfo;
    },
    /**
     * @description: logout
     */
    async logout(goLogin = false) {
      if (this.getToken) {
        try {
          await UserApi.logout();
        } catch {
          console.log('注销Token失败');
        }
      }
      this.setToken(undefined);
      this.setSessionTimeout(false);
      this.setUserInfo(null);
      goLogin && router.push(PageEnum.BASE_LOGIN);
    },

    /**
     * @description: Confirm before logging out
     */
    confirmLoginOut() {
      const { createConfirm } = useMessage();
      const { t } = useI18n();
      createConfirm({
        iconType: 'warning',
        title: () => h('span', t('sys.app.logoutTip')),
        content: () => h('span', t('sys.app.logoutMessage')),
        onOk: async () => {
          await this.logout(true);
        },
      });
    },
    setUserNavList(navList: DataItem[]) {
      this.navList = navList;
    },
  },
});

// Need to be used outside the setup
export function useUserStoreWithOut() {
  return useUserStore(store);
}
